#include <iostream>
#include <string>
#include <sstream>

using namespace std;

// -------------------------------------------------------------------------------------------------------------
// Functions for Question 1.
// -------------------------------------------------------------------------------------------------------------
double CalculateAverage(const double *pData, int count)
{
	const double *pEnd = pData + count;
	double total = 0;

	while (pData != pEnd)
	{
		total += *pData++;
	}
	return total / count;
}


// -------------------------------------------------------------------------------------------------------------
// Functions for Question 2.
// -------------------------------------------------------------------------------------------------------------
const double * FindMax(const double *pData, int count)
{
	const double *pLargest = pData;
	const double *pEnd = pData + count;

	// Loop through all elements, to see which is the largest.
	for (const double *pEnd = pData + count; pData != pEnd; pData++)
	{
		if (*pData > *pLargest) 
		{
			pLargest = pData;
		}
	}
	return pLargest;
}

// -------------------------------------------------------------------------------------------------------------
// Functions for Question 3.
// -------------------------------------------------------------------------------------------------------------
void FindMinAndMax(const double * pData, int count, const double **ppMin, const double ** ppMax)
{
	// Set first element as min and max element, as a starting point.
	*ppMin = pData;
	*ppMax = pData;
	
	// Loop through all elements, to see which is the smallest and largest.
	for (const double *pEnd = pData + count; pData != pEnd; pData++)
	{
		if (*pData < **ppMin) 
		{
			*ppMin = pData;
		}

		if (*pData > **ppMax) 
		{
			*ppMax = pData;
		}
	}
}


// -------------------------------------------------------------------------------------------------------------
// Functions for Question 4.
// -------------------------------------------------------------------------------------------------------------
void GetTwoNumbersFromUser(const string& prompt, int& num1, int & num2)
{
	cout << endl << prompt;
	cin >> num1;
	cin >> num2;
}
